// FILENAME:	CnH_Testbed.cs
//
//------------------------------------------------------------------------------

$missionName = "CnH_Testbed";

exec("multiplayerStdLib.cs");
exec("CnHStdLib.cs");


function setDefaultMissionOptions()
{
	$server::TeamPlay = true;
	$server::AllowDeathmatch = true;
	$server::AllowTeamPlay = true;	

   // what can the client choose for a team
	$server::AllowTeamRed = false;
	$server::AllowTeamBlue = false;
	$server::AllowTeamYellow = true;
	$server::AllowTeamPurple = true;

   // what can the server admin choose for available teams
   $server::disableTeamRed = true;
   $server::disableTeamBlue = true;
   $server::disableTeamYellow = false;
   $server::disableTeamPurple = false;
}


function onMissionStart()
{
  %capture1 = getObjectId("MissionGroup\\B1\\trigger");
  %capture1.timeToCapture = 5;
  %capture1.timeCounted = 0;
  %capture1.lastVehicle = 0;
  %capture1.owner = 0;
  %capture1.secondsToHold = 60;
  %capture1.heldFor = 0;
  %capture1.name = "Alpha Base";
  %capture1.points = 10;
  %capture1.zen = 1;
  %capture1.spoils = 6;
  %capture1.spoil[0] = "MissionGroup\\B1\\T1";
  %capture1.spoil[1] = "MissionGroup\\B1\\T2";
  %capture1.spoil[2] = "MissionGroup\\B1\\T3";
  %capture1.spoil[3] = "MissionGroup\\B1\\T4";
  %capture1.spoil[4] = "MissionGroup\\B1\\nav";
  %capture1.spoil[5] = "MissionGroup\\B1\\Tcontrol";

  %capture2 = getObjectId("MissionGroup\\B2\\trigger");
  %capture2.timeToCapture = 5;
  %capture2.timeCounted = 0;
  %capture2.lastVehicle = 0;
  %capture2.owner = 0;
  %capture2.secondsToHold = 60;
  %capture2.heldFor = 0;
  %capture2.name = "Bravo Base";
  %capture2.points = 10;
  %capture2.zen = 1;
  %capture2.spoils = 6;
  %capture2.spoil[0] = "MissionGroup\\B2\\T1";
  %capture2.spoil[1] = "MissionGroup\\B2\\T2";
  %capture2.spoil[2] = "MissionGroup\\B2\\T3";
  %capture2.spoil[3] = "MissionGroup\\B2\\T4";
  %capture2.spoil[4] = "MissionGroup\\B2\\nav";
  %capture2.spoil[5] = "MissionGroup\\B2\\Tcontrol";

  %capture3 = getObjectId("MissionGroup\\B3\\trigger");
  %capture3.timeToCapture = 5;
  %capture3.timeCounted = 0;
  %capture3.lastVehicle = 0;
  %capture3.owner = 0;
  %capture3.secondsToHold = 60;
  %capture3.heldFor = 0;
  %capture3.name = "Charlie Base";
  %capture3.points = 10;
  %capture3.zen = 1;
  %capture3.spoils = 5;
  %capture3.spoil[0] = "MissionGroup\\B3\\T1";
  %capture3.spoil[1] = "MissionGroup\\B3\\T2";
  %capture3.spoil[2] = "MissionGroup\\B3\\T3";
  %capture3.spoil[3] = "MissionGroup\\B3\\nav";
  %capture3.spoil[4] = "MissionGroup\\B3\\Tcontrol";


  %capture4 = getObjectId("MissionGroup\\B4\\trigger");
  %capture4.timeToCapture = 5;
  %capture4.timeCounted = 0;
  %capture4.lastVehicle = 0;
  %capture4.owner = 0;
  %capture4.secondsToHold = 60;
  %capture4.heldFor = 0;
  %capture4.name = "Delta Base";
  %capture4.points = 10;
  %capture4.zen = 1;
  %capture4.spoils = 5;
  %capture4.spoil[0] = "MissionGroup\\B4\\T1";
  %capture4.spoil[1] = "MissionGroup\\B4\\T2";
  %capture4.spoil[2] = "MissionGroup\\B4\\T3";
  %capture4.spoil[3] = "MissionGroup\\B4\\nav";
  %capture4.spoil[4] = "MissionGroup\\B4\\Tcontrol";


  $numOfBases = 4;
  $capture[1] = %capture1;
  $capture[2] = %capture2;
  $capture[3] = %capture3;
  $capture[4] = %capture4;


  %teleport1 = "MissionGroup\\B1\\teleport";
  %teleport1.controller = getObjectId("MissionGroup\\B1\\Tcontrol");
  %teleport2 = "MissionGroup\\B2\\teleport";
  %teleport2.controller = getObjectId("MissionGroup\\B2\\Tcontrol");
  %teleport3 = "MissionGroup\\B3\\teleport";
  %teleport3.controller = getObjectId("MissionGroup\\B3\\Tcontrol");
  %teleport4 = "MissionGroup\\B4\\teleport";
  %teleport4.controller = getObjectId("MissionGroup\\B4\\Tcontrol");
  %teleport5 = "MissionGroup\\YellowBase\\teleport";
  %teleport5.controller = getObjectId("MissionGroup\\YellowBase\\Tcontrol");
  %teleport6 = "MissionGroup\\PurpleBase\\teleport";
  %teleport6.controller = getObjectId("MissionGroup\\PurpleBase\\Tcontrol");

  windSounds();
  mercurySounds();
}


function onMissionLoad()
{
   cdAudioCycle("CloudBurst", "Newtech", "Mechsoul");
}


function gateway::structure::onScan(%this, %object, %string)
{
  %player = playerManager::vehicleIdToPlayerNum(%object);

  %a = strAlign(1, left, getTeam(%this) );
  say(0, 0, %a);
  %b = strAlign(1, left, %player.color);
  say(0, 0, %b);

  if(%a != %b) 
  {
    say(%player, 0, "Teleport controls not set for your team");
    return;
  }

  %player.destination++;
  %target = $capture[%player.destination];

  %a = strAlign(1, left, %target.owner);
  %b = strAlign(1, left, %player.color);

  while( %a != %b )
  {
    %player.destination++;
    %target = $capture[%player.destination];
    %a = strAlign(1, left, %target.owner);

    if(%player.destination > $numOfBases)
    {
      %player.destination = 0;
      %a = %b;
    }
  }

  if(%player.destination == 0) say(%player, 0, "Destination: Home base");
  else
  {
    say(%player, 0, "Destination: " @ %target.name);
  }
}


function teleporter::trigger::onEnter(%trigger, %object)
{
  %player = playerManager::vehicleIdToPlayerNum(%object);

  say(0, 0, %trigger.controller);
  %a = strAlign(1, left, getTeam(%trigger.controller) );
  say(0, 0, %a);
  %b = strAlign(1, left, %player.color);
  say(0, 0, %b);

  if(%a != %b) 
  {
    say(%player, 0, "Teleport controls not set for your team");
    return;
  }

  if(%player.destination != 0)
  {
    %target = $capture[%player.destination];

    %x = getPosition(%target, x);
    %y = getPosition(%target, y);

    %x1 = %x + randomInt(-500, 500);
    %y1 = %y + randomInt(-500, 500);
    %z1 = getTerrainHeight(%x1, %y2) + 10;

    setPosition(%object, %x1, %y1, %z1);
  }
  else
  {
    redrop(%object);
    return;
  }
}


function player::onAdd(%player)
{
  %player.seizures = 0;
  %player.destination = 0;
  say(%player, 0, "New features test for Capture and Hold.  Scan the teleporters to toggle between bases your team controls");
}   



function remoteGetMyTargetName(%player)
{
  %vehicle = playerManager::playerNumToVehicleId(%player);
  %target = getTargetId(%vehicle);
  %targetName = getHUDName(%target);

  %color = getTeam(%vehicle);
  if(%color == *IDSTR_TEAM_YELLOW) say(IDSTR_TEAM_YELLOW, 0, "Everyone attack " @ %targetName @ "!");    
  if(%color == *IDSTR_TEAM_BLUE) say(IDSTR_TEAM_BLUE, 0, "Everyone attack " @ %targetName @ "!");    
  if(%color == *IDSTR_TEAM_RED) say(IDSTR_TEAM_RED, 0, "Everyone attack " @ %targetName @ "!");    
  if(%color == *IDSTR_TEAM_PURPLE) say(IDSTR_TEAM_PURPLE, 0, "Everyone attack " @ %targetName @ "!");    
}



function getMyPosition(%playerID)
{
  %vehicleID = playerManager::playerNumToVehicleID(%playerID);
  %vehicleID.x = getPosition(%vehicleID, x);
  %vehicleID.y = getPosition(%vehicleID, y);
}


function dropMyNavMarker(%playerID)
{
  %vehicleID = playerManager::playerNumToVehicleID(%playerID);
  playerDropNavMarker(%vehicleID.x, %vehicleID.y);
}


function remoteDropMyNavHere(%playerID)
{
  getMyPosition(%playerID);
  dropMyNavMarker(%playerID);
}